import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

public class loadInfoServ extends GenericServlet { 

	static PrintWriter out = null; 

	public void service(ServletRequest req, ServletResponse res)
		throws ServletException, IOException {

		System.out.println("Enter loadInfoServ...");
		res.setContentType("text/html");

		String domain   = req.getParameter("domain");
		System.out.println("domain got from AES: " + domain);
		String cluster  = req.getParameter("cluster");
//		String machines = req.getParameter("machines");
		String os       = req.getParameter("OS");
		String arch     = req.getParameter("Arch");
		String DrepIP   = req.getParameter("DrepIP");
		String DrepPort = req.getParameter("DrepPort");
		String DrepDBA  = req.getParameter("DrepDBA");

		String query = "Select RepIP, RepPortNo, DBAName from DomainT ";
		query += "where Domain='" + domain + "'";

		ResultSet rs = null;
		String title = "servlet load measurement Output";

		String repIP     = DrepIP;
		String repPortNo = DrepPort; 
		String dba       = DrepDBA;
		String dbname    = ""; 	// Oct.17, added dbname

		try {
			Class.forName("COM.imaginary.sql.msql.MsqlDriver");
			String url = "jdbc:msql://" + DrepIP + ":" + DrepPort + "/VDCE";
			Connection con = DriverManager.getConnection(url, DrepDBA, "");
			Statement sqlstmt = con.createStatement();
			rs = sqlstmt.executeQuery(query);
			while (rs.next()) {
				repIP = rs.getString(1);
				repPortNo = rs.getString(2);
				dba = rs.getString(3);
			}
			rs.close();
			sqlstmt.close();
			con.close();
		}
		catch (Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

		query = "select IP, PortNo, DBAName, DBName from ClusterT";
		query += " where Cluster='" + cluster + "'"; 
		try {
			Class.forName("COM.imaginary.sql.msql.MsqlDriver");
			String url = "jdbc:msql://" + repIP + ":" + repPortNo + "/VDCE";
			Connection con = DriverManager.getConnection(url, dba, "");
			Statement sqlstmt = con.createStatement();
			rs = sqlstmt.executeQuery(query);
			while (rs.next()) {
				repIP     = rs.getString(1);
				repPortNo = rs.getString(2);
				dba       = rs.getString(3);
				dbname    = rs.getString(4);	// added on Oct.17, 1997
			}
			rs.close();
			sqlstmt.close();
			con.close();
		}
		catch (Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

		query = "Select alias, load_1, OS, total_process, memory_real, memory_free "
				+ "from Resource where OS='" 
				+ os + "'" + " and Arch='" + arch + "'";

		try {
			Class.forName("COM.imaginary.sql.msql.MsqlDriver");
			String url = "jdbc:msql://" + repIP + ":" + repPortNo + "/" + dbname;
			Connection con = DriverManager.getConnection(url, dba, "");
			Statement sqlstmt = con.createStatement();
			rs = sqlstmt.executeQuery(query);
			out = new PrintWriter(res.getOutputStream());

			String name;
			while (rs.next()) {
				name = rs.getString(1);
				String load = rs.getString(2);
				if (load.length() > 4) {
					load = load.substring(0, 3);
				}
				out.println(rs.getString(1) + " " + load + " "
					+ rs.getString(3) + " " + rs.getString(4)+ " "
					+ rs.getString(5) + " " + rs.getString(6));
			}
			rs.close();
			sqlstmt.close();
			out.flush();
			out.close();
			con.close();
		}
		catch (Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
		System.out.print("load..");
	}

	public String getServletInfo() {
		return " servlet for getting Load measuring data from database";
	}
}
